import React, { useState, useEffect } from 'react'

function ApiData() {
  const [data, setData] = useState([])

  useEffect(() => {
    fetch('https://swapi.co/api/people')
      .then(response => response.json())
      .then(data => setData(data.results))
      .catch(error => {
        console.error('Error:', error)
      })
  }, [])

  return (
    <>
      <h2>API Data</h2>
      {data.map(item => (
        <div key={item.url}>{item.name}</div>
      ))}
    </>
  )
}

export default ApiData
