import React, { useState, useEffect } from 'react'

function ApiSandbox() {
  const [data, setData] = useState([])

  useEffect(() => {
    fetch('https://swapi.co/api/people')
      .then(response => response.json())
      .then(data => setData(data.results))
      .catch(error => {
        console.error('Error:', error)
      })
  }, [])

  const createIssue = newIssue => {
    fetch('/api/post', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(newIssue)
    })
      .then(response => response.json())
      .then(data => {
        console.log('Success:', data)
      })
      .catch(error => {
        console.error('Error:', error)
      })
  }

  return (
    <>
      <h2>API Sandbox</h2>
      {data.map(item => (
        <div key={item.url}>{item.name}</div>
      ))}
      <button onClick={() => createIssue({ test: 'aaa', test2: 'bb' })}>
        POST request
      </button>
    </>
  )
}

export default ApiSandbox
