/** @jsx jsx */
import React, { useState } from 'react'
import { css, jsx } from '@emotion/core'
import { SketchPicker } from 'react-color'

function Colors(props) {
  const parameters = props.parameters

  const setParameters = props.setParameters

  const [picker, setPicker] = useState(false)

  const [bgPicker, setBgPicker] = useState(false)

  const handleColorChange = color => {
    setParameters({ ...parameters, color: color.hex })
  }

  const handleBgColorChange = color => {
    setParameters({ ...parameters, bgColor: color.hex })
  }

  return (
    <>
      <div>
        <h2>Zvolte barvy:</h2>
        <div className='column'>
          <label>Barva skříně:</label>
          <div
            css={css`
              position: relative;
            `}
          >
            {picker === true && (
              <div
                css={css`
                  position: absolute;
                  z-index: 2;
                  top: 40px;
                `}
              >
                <div
                  css={css`
                    position: fixed;
                    left: 0;
                    right: 0;
                    top: 0;
                    bottom: 0;
                  `}
                  onClick={() => setPicker(false)}
                ></div>
                <SketchPicker
                  color={parameters.color}
                  onChange={handleColorChange}
                />
              </div>
            )}
            <input
              type='text'
              name='color'
              value={parameters.color}
              onClick={() => setPicker(true)}
            />
          </div>
        </div>
        <div className='column'>
          <label>Barva stěny:</label>
          <div
            css={css`
              position: relative;
            `}
          >
            {bgPicker === true && (
              <div
                css={css`
                  position: absolute;
                  z-index: 2;
                  top: 40px;
                `}
              >
                <div
                  css={css`
                    position: fixed;
                    left: 0;
                    right: 0;
                    top: 0;
                    bottom: 0;
                  `}
                  onClick={() => setBgPicker(false)}
                ></div>
                <SketchPicker
                  color={parameters.bgColor}
                  onChange={handleBgColorChange}
                />
              </div>
            )}
            <input
              type='text'
              name='bgColor'
              value={parameters.bgColor}
              onClick={() => setBgPicker(true)}
            />
          </div>
        </div>
      </div>
    </>
  )
}

export default Colors
