/** @jsx jsx */
import { css, jsx } from '@emotion/core'
import React from 'react'
import { Canvas, extend } from 'react-three-fiber'
import { OrbitControls } from 'three/examples/jsm/controls/OrbitControls'
import Scene from './scene'

extend({ OrbitControls })

function Designer(props) {
  return (
    <div
      css={css`
        background: ${props.parameters.bgColor};
        border: 1px solid #d1b283;
        border-radius: 10px;
      `}
    >
      <div
        css={css`
          height: 700px;
        `}
      >
        <Canvas camera={{ position: [-1.2, 0.4, 2.6] }}>
          <Scene
            parameters={props.parameters}
            setParameters={props.setParameters}
          />
        </Canvas>
      </div>
    </div>
  )
}

export default Designer
