/** @jsx jsx */
import React, { useState } from 'react'
import { css, jsx } from '@emotion/core'
import Slider from '@material-ui/core/Slider'
import Input from '@material-ui/core/Input'
import { SketchPicker } from 'react-color'

function Main(props) {
  const parameters = props.parameters

  const setParameters = props.setParameters

  function handleChange(e) {
    const value = e.target.value
    setParameters({ ...parameters, [e.target.name]: value })
  }

  function handleChangeDesks(e) {
    const value = e.target.value
    const array = Array(5)
      .fill(1)
      .map((el, j) => {
        return value
      })
    setParameters({ ...parameters, configuration: array })
  }

  const handleSliderHeightChange = (event, newValue) => {
    setParameters({ ...parameters, height: newValue })
  }

  const handleInputHeightChange = event => {
    setParameters({
      ...parameters,
      height: Number(event.target.value)
    })
  }

  const handleSliderWidthChange = (event, newValue) => {
    setParameters({ ...parameters, width: newValue })
  }

  const handleInputWidthChange = event => {
    setParameters({
      ...parameters,
      width: Number(event.target.value)
    })
  }

  const handleSliderDepthChange = (event, newValue) => {
    setParameters({ ...parameters, depth: newValue })
  }

  const handleInputDepthChange = event => {
    setParameters({
      ...parameters,
      depth: Number(event.target.value)
    })
  }

  const handleSliderDeskWidthChange = (event, newValue) => {
    setParameters({ ...parameters, deskWidth: newValue })
  }

  const handleInputDeskWidthChange = event => {
    setParameters({
      ...parameters,
      deskWidth: Number(event.target.value)
    })
  }

  return (
    <>
      <div>
        <h2>Zvolte základní rozměry skříně:</h2>
        <div
          css={css`
            .inputWrapper {
              display: flex;
              input {
                margin-right: 10px;
              }
            }
          `}
          className='column'
        >
          <label>Výška:</label>
          <div>
            <Slider
              value={parameters.height}
              onChange={handleSliderHeightChange}
              aria-labelledby='input-slider'
              min={0.5}
              step={0.01}
              max={4}
            />
            <div className='inputWrapper'>
              <Input
                value={parameters.height}
                onChange={handleInputHeightChange}
                inputProps={{
                  step: 0.01,
                  min: 0.5,
                  max: 4,
                  type: 'number'
                }}
              />
              m
            </div>
          </div>
          <label>Šířka:</label>
          <div>
            <Slider
              value={parameters.width}
              onChange={handleSliderWidthChange}
              aria-labelledby='input-slider'
              min={0.5}
              step={0.01}
              max={4}
            />
            <div className='inputWrapper'>
              <Input
                value={parameters.width}
                onChange={handleInputWidthChange}
                inputProps={{
                  step: 0.01,
                  min: 0.5,
                  max: 4,
                  type: 'number'
                }}
              />
              m
            </div>
          </div>
          <label>Hloubka:</label>
          <div>
            <Slider
              value={parameters.depth}
              onChange={handleSliderDepthChange}
              aria-labelledby='input-slider'
              min={0.3}
              step={0.01}
              max={2}
            />
            <div className='inputWrapper'>
              <Input
                value={parameters.depth}
                onChange={handleInputDepthChange}
                inputProps={{
                  step: 0.01,
                  min: 0.3,
                  max: 2,
                  type: 'number'
                }}
              />
              m
            </div>
          </div>
          <label>Tloušťka stěny:</label>
          <div>
            <Slider
              value={parameters.deskWidth}
              onChange={handleSliderDeskWidthChange}
              aria-labelledby='input-slider'
              min={0.01}
              step={0.01}
              max={0.04}
            />
            <div className='inputWrapper'>
              <Input
                value={parameters.deskWidth}
                onChange={handleInputDeskWidthChange}
                inputProps={{
                  step: 0.01,
                  min: 0.3,
                  max: 2,
                  type: 'number'
                }}
              />
              m
            </div>
          </div>
        </div>
        <h2>Zvolte počet polic:</h2>
        <div className='column'>
          <label>Počet polic:</label>
          <select
            name={`configuration[${
              parameters.configuration[parameters.currentPart - 1]
            }]`}
            value={parameters.configuration[parameters.currentPart - 1]}
            onChange={e => handleChangeDesks(e)}
          >
            <option value='0'>Bez poliček</option>
            <option value='1'>1</option>
            <option value='2'>2</option>
            <option value='3'>3</option>
            <option value='4'>4</option>
            <option value='5'>5</option>
          </select>
        </div>
        <h2>Zvolte počet dílů skříně:</h2>
        <div className='column'>
          <label>Počet dílů:</label>
          <select
            name='parts'
            value={parameters.parts}
            onChange={e => handleChange(e)}
          >
            <option value='1'>1</option>
            <option value='2'>2</option>
            <option value='3'>3</option>
            <option value='4'>4</option>
            <option value='5'>5</option>
          </select>
        </div>
        <h2>Stěny:</h2>
        <div className='column'>
          <label>Zadní stěna:</label>
          <select
            value={parameters.backDesk}
            onChange={e => handleChange(e)}
            name='backDesk'
          >
            <option value='1'>Ano</option>
            <option value='0'>Ne</option>
          </select>
        </div>
        <div className='column'>
          <label>Vrchní stěna:</label>
          <select
            value={parameters.topDesk}
            onChange={e => handleChange(e)}
            name='topDesk'
          >
            <option value='1'>Ano</option>
            <option value='0'>Ne</option>
          </select>
        </div>
        <div className='column'>
          <label>Spodní stěna:</label>
          <select
            value={parameters.bottomDesk}
            onChange={e => handleChange(e)}
            name='bottomDesk'
          >
            <option value='1'>Ano</option>
            <option value='0'>Ne</option>
          </select>
        </div>
      </div>
    </>
  )
}

export default Main
