/** @jsx jsx */
import React, { useState } from 'react'
import { css, jsx } from '@emotion/core'
import { SketchPicker } from 'react-color'

function Parts(props) {
  const parameters = props.parameters

  const setParameters = props.setParameters

  const [picker, setPicker] = useState(false)

  const handleColorChange = color => {
    setParameters({ ...parameters, currentColor: color.hex })
  }

  function handleChange(e) {
    const value =
      e.target.name === 'showCurrent' ? e.target.checked : e.target.value
    setParameters({ ...parameters, [e.target.name]: value })
  }

  function handleChangeDesks(e) {
    const value = e.target.value
    const array = Array(5)
      .fill(1)
      .map((el, j) => {
        if (j + 1 === parameters.currentPart) {
          return value
        } else {
          return parameters.configuration[j]
        }
      })
    setParameters({ ...parameters, configuration: array })
  }

  return (
    <>
      <h2>Zvolte počet polic:</h2>
      <div className='column'>
        <label>Počet polic:</label>
        <select
          name={`configuration[${
            parameters.configuration[parameters.currentPart - 1]
          }]`}
          value={parameters.configuration[parameters.currentPart - 1]}
          onChange={e => handleChangeDesks(e)}
        >
          <option value='0'>Bez poliček</option>
          <option value='1'>1</option>
          <option value='2'>2</option>
          <option value='3'>3</option>
          <option value='4'>4</option>
          <option value='5'>5</option>
        </select>
      </div>
      <h2>Zvolte barvu pro označení aktuálně vybrané skříně:</h2>
      <div className='column'>
        <label>Barva:</label>
        <div
          css={css`
            position: relative;
          `}
        >
          {picker === true && (
            <div
              css={css`
                position: absolute;
                z-index: 2;
                top: 40px;
              `}
            >
              <div
                css={css`
                  position: fixed;
                  left: 0;
                  right: 0;
                  top: 0;
                  bottom: 0;
                `}
                onClick={() => setPicker(false)}
              ></div>
              <SketchPicker
                color={parameters.currentColor}
                onChange={handleColorChange}
              />
            </div>
          )}
          <input
            type='text'
            name='color'
            value={parameters.currentColor}
            onClick={() => setPicker(true)}
          />
        </div>
      </div>
      <label
        css={css`
          display: flex;
          align-items: center;
          margin-bottom: 15px;
          cursor: pointer;
        `}
      >
        <input
          name='showCurrent'
          type='checkbox'
          checked={parameters.showCurrent}
          onChange={e => handleChange(e)}
          css={css`
            display: flex;
            align-items: center;
            margin-right: 10px;
            margin-top: 6px;
          `}
        />
        zvýraznit aktuálně vybranou skříň
      </label>
    </>
  )
}

export default Parts
