/** @jsx jsx */
import React from 'react'
import { css, jsx } from '@emotion/core'

function TwoCols(props) {
  return (
    <div
      css={css`
        display: grid;
        grid-template-columns: auto;
        flex: 1;
        .column {
          display: grid;
          grid-template-columns: 50% 50%;
          margin-bottom: 15px;
          align-items: center;
        }
        h2 {
          background: #3c3941;
          color: #e7e2f6;
          font-size: 16px;
          padding: 10px;
          margin-top: 0;
          margin-top: 10px;
        }
        @media only screen and (min-width: 768px) {
          grid-template-columns: 33% 67%;
        }
      `}
    >
      {props.children}
    </div>
  )
}

export default TwoCols
